#-*-coding:utf8-*-
import math,os,glob
from generalSub import *

class changeDictionary:

    def __init__(self,caseDir):
        self.caseDir=caseDir

    #-- get boundary name---------------------------------------------------------------------------------------
    def getBCNameRegion(self,foldername,regionName):
        aa=foldername+'/constant/'+regionName+'/polyMesh/boundary'
        filea=open(aa);lines=filea.readlines();filea.close()
	for ii in lines:
	    if ii=='\n':lines.remove(ii)
	num=int(lines[16])
        line1=[];bcname=[]
        f=open(aa,'r')
        for i in range(15,len(lines)):
            a=(lines[i]).strip()
            if a=='{':line1.append(i)            
        for i in line1:
            b=(lines[i-1]).strip();bcname.append(b)
        return bcname
    #-- get boundary type from polyMesh/boundary file ------------------------------------------------------------------
    def getBCTypeRegion(self,foldername,regionName):
        aa=foldername+'/constant/'+regionName+'/polyMesh/boundary'
        filea=open(aa,'r');lines=filea.readlines();filea.close()
	for ii in lines:
	    if ii=='\n':lines.remove(ii)
	num=int(lines[16])
        line1=[];bctype=[]
        f=open(aa,'r')
        for i in range(15,len(lines)):
            a=(lines[i]).strip()
            if a=='{':line1.append(i)            
        for i in line1:
            bb=(lines[i+1]).split();bb1=(bb[1])[:-1];bctype.append(bb1)
        return bctype
    #------------------------------------------------------------------------------
    def UFile(self,flowCondition,startFrom,startTime,nCore,rho,internalField):

	uini='('+internalField[0]+' '+internalField[1]+' '+internalField[2]+')'

	GEN=generalClass(self.caseDir)

	aa=glob.glob(self.caseDir+'/processor*')
	if len(aa)==0:
	    if startFrom=='startTime':
	        if startTime!='0':opt=' -time '+startTime
	        else:opt=' '
	    else:opt=' -latestTime'
	else:
	    if nCore!='1':
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime+' -parallel'
	            else:opt=' '
	        else:opt=' -latestTime -parallel'
	    else:
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime
	            else:opt=' '
	        else:opt=' -latestTime'

	bcname=GEN.getBCName();bctype=GEN.getBCType()

	for j in range(len(bcname)):
	    pp=bcname[j]
	    if bctype[j]=='wall' or bctype[j]=='patch' or bctype[j]=='mappedWall':
		condition=flowCondition[bcname[j]]
		patchType=condition[1];patchValue=[condition[2],condition[3],condition[4]]
		if patchType=='wall':
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value fixedValue'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+" -entry value -value '(0 0 0)'"+opt)
		elif patchType=='moving-wall' or patchType=='fixed-U':
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value fixedValue'+opt)
		    valuestr="'("+patchValue[0]+' '+patchValue[1]+' '+patchValue[2]+")'"
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry value -value '+valuestr+opt)
		elif patchType=='surfaceNormal-U':
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value surfaceNormalFixedValue'+opt)
		    if float(patchValue[0]) > 0 :refv='-'+patchValue[0]
		    else:
			aa=float(patchValue[0])*-1;refv='-'+aa
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry refValue -value '+refv+opt)
		elif patchType=='volume-flowrate':
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value flowRateInletVelocity'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry volumetricFlowRate -value '+patchValue[0]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry value -value '+"'"+uini+"'"+opt)
		elif patchType=='mass-flowrate':
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value flowRateInletVelocity'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry massFlowRate -value '+patchValue[0]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry rho -value rho'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry rhoInlet -value '+rho+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry value -value '+"'"+uini+"'"+opt)
		elif patchType=='total-pressure':
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value zeroGradient'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry value -value '+"'"+uini+"'"+opt)
		elif patchType=='outlet':
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value pressureInletOutletVelocity'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry value -value '+"'"+uini+"'"+opt)
		elif patchType=='movingWallVelocity':
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value movingWallVelocity'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+" -entry value -value '(0 0 0)'"+opt)
		elif patchType=='rotatingWallVelocity':
		    if patchValue[1]=='x':axis='(1 0 0)'
		    elif patchValue[1]=='y':axis='(0 1 0)'
		    elif patchValue[1]=='z':axis='(0 0 1)'
		    elif patchValue[1]=='-x':axis='(-1 0 0)'
		    elif patchValue[1]=='-y':axis='(0 -1 0)'
		    elif patchValue[1]=='-z':axis='(0 0 -1)'
		    omega=float(patchValue[2])*2*3.141592/60;omega=str(omega)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value rotatingWallVelocity'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry origin -value '+"'"+patchValue[0]+"'"+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry axis -value '+"'"+axis+"'"+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry omega -value '+omega+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+" -entry value -value '(0 0 0)'"+opt)
	    elif bctype[j]=='symmetry':os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value symmetry'+opt)
	    elif bctype[j]=='symmetryPlane':os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value symmetryPlane'+opt)
	    elif bctype[j]=='empty':os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value empty'+opt)
	    elif bctype[j]=='cyclic':os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value cyclic'+opt)
	    elif bctype[j]=='cyclicAMI':os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value cyclicAMI'+opt)

	if opt==' ':opt='0'
	print 'U Boundary Conditions are set as '+opt

    #------------------------------------------------------------------------------
    def pFile(self,flowCondition,jump,startFrom,startTime,nCore,internalField):

	GEN=generalClass(self.caseDir)
	pini=internalField[3]

	aa=glob.glob(self.caseDir+'/processor*')
	if len(aa)==0:
	    if startFrom=='startTime':
	        if startTime!='0':opt=' -time '+startTime
	        else:opt=' '
	    else:opt=' -latestTime'
	else:
	    if nCore!='1':
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime+' -parallel'
	            else:opt=' '
	        else:opt=' -latestTime -parallel'
	    else:
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime
	            else:opt=' '
	        else:opt=' -latestTime'

	bcname=GEN.getBCName();bctype=GEN.getBCType()

	for j in range(len(bcname)):
	    pp=bcname[j]
	    if bctype[j]=='wall' or bctype[j]=='patch':
		condition=flowCondition[bcname[j]]
		patchType=condition[1];patchValue=[condition[2],condition[3],condition[4]]
		if patchType=='total-pressure':
	            os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry type -value totalPressure'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry gamma -value 1.4'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry p0 -value '+patchValue[0]+opt)
		elif patchType=='outlet':
	            os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry type -value fixedValue'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry value -value '+patchValue[0]+opt)
		else:
	            os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry type -value zeroGradient'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry value -value '+pini+opt)
	    elif bctype[j]=='mappedWall':
	        os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry type -value zeroGradient'+opt)
	        os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry value -value '+pini+opt)
	    elif bctype[j]=='cyclic':
		aa=jump.keys();bb=aa.count(bcname[j])
		if bb!=0:
	            os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry type -value porousJumpPressure'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry patchType -value cyclic'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry value -value '+patchValue[0]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry D -value '+jump[bcname[j]][0]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry I -value '+jump[bcname[j]][1]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry length -value '+jump[bcname[j]][2]+opt)
	    	else:
		    os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry type -value cyclic'+opt)
	    elif bctype[j]=='symmetry':os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry type -value symmetry'+opt)
	    elif bctype[j]=='symmetryPlane':os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry type -value symmetryPlane'+opt)
	    elif bctype[j]=='empty':os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry type -value empty'+opt)
	    elif bctype[j]=='cyclicAMI':os.system('changeBCs -case '+self.caseDir+ ' -field p -patch '+pp+' -entry type -value cyclicAMI'+opt)

	if opt==' ':opt='0'
	print 'p Boundary Conditions are set as '+opt
    #------------------------------------------------------------------------------
    def kFile(self,turCondition,startFrom,startTime,nCore,internalField):

	GEN=generalClass(self.caseDir)
	kini=internalField[4]

	aa=glob.glob(self.caseDir+'/processor*')
	if len(aa)==0:
	    if startFrom=='startTime':
	        if startTime!='0':opt=' -time '+startTime
	        else:opt=' '
	    else:opt=' -latestTime'
	else:
	    if nCore!='1':
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime+' -parallel'
	            else:opt=' '
	        else:opt=' -latestTime -parallel'
	    else:
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime
	            else:opt=' '
	        else:opt=' -latestTime'

	bcname=GEN.getBCName();bctype=GEN.getBCType()

	for j in range(len(bcname)):
	    pp=bcname[j]
	    if bctype[j]=='wall' or bctype[j]=='patch':
		condition=turCondition[bcname[j]]
		patchType=condition[1];patchValue=[condition[2],condition[3]]
		if patchType=='wallFunction':
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value kqRWallFunction'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry value -value '+kini+opt)
		elif patchType=='fixed-Value':
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value fixedValue'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry value -value '+patchValue[0]+opt)
		elif patchType=='zeroGradient':
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value zeroGradient'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry value -value '+kini+opt)
		elif patchType=='inletOutlet':
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value inletOutlet'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry inletValue -value '+patchValue[0]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry value -value '+kini+opt)
	    elif bctype[j]=='mappedWall':
	        os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value kqRWallFunction'+opt)
	        os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry value -value '+kini+opt)
	    elif bctype[j]=='symmetry':os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value symmetry'+opt)
	    elif bctype[j]=='symmetryPlane':os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value symmetryPlane'+opt)
	    elif bctype[j]=='empty':os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value empty'+opt)
	    elif bctype[j]=='cyclic':os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value cyclic'+opt)
	    elif bctype[j]=='cyclicAMI':os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value cyclicAMI'+opt)

	if opt==' ':opt='0'
	print 'k Boundary Conditions are set as '+opt
    #------------------------------------------------------------------------------
    def epsilonFile(self,turCondition,startFrom,startTime,nCore,internalField,turbulenceModel):

	GEN=generalClass(self.caseDir)
	eini=internalField[5]

	wallfunc='epsilonWallFunction'
	if turbulenceModel=='standardKEpsilon':wallfunc='epsilonStdWallFunction'
	elif turbulenceModel=='realizableKEpsilon':wallfunc='epsilonStdWallFunction'
	elif turbulenceModel=='renormalizationGroupKEpsilon':wallfunc='epsilonStdWallFunction'
	elif turbulenceModel=='shearStressTransportKOmega':wallfunc='epsilonStdWallFunction'

	aa=glob.glob(self.caseDir+'/processor*')
	if len(aa)==0:
	    if startFrom=='startTime':
	        if startTime!='0':opt=' -time '+startTime
	        else:opt=' '
	    else:opt=' -latestTime'
	else:
	    if nCore!='1':
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime+' -parallel'
	            else:opt=' '
	        else:opt=' -latestTime -parallel'
	    else:
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime
	            else:opt=' '
	        else:opt=' -latestTime'

	bcname=GEN.getBCName();bctype=GEN.getBCType()

	for j in range(len(bcname)):
	    pp=bcname[j]
	    if bctype[j]=='wall' or bctype[j]=='patch':
		condition=turCondition[bcname[j]]
		patchType=condition[1];patchValue=[condition[2],condition[3]]
		if patchType=='wallFunction':
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value '+wallfunc+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry value -value '+eini+opt)
		elif patchType=='fixed-Value':
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value fixedValue'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry value -value '+patchValue[1]+opt)
		elif patchType=='zeroGradient':
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value zeroGradient'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry value -value '+eini+opt)
		elif patchType=='inletOutlet':
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value inletOutlet'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry inletValue -value '+patchValue[1]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry value -value '+eini+opt)
	    elif bctype[j]=='mappedWall':
	        os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value '+wallfunc+opt)
	        os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry value -value '+eini+opt)
	    elif bctype[j]=='symmetry':os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value symmetry'+opt)
	    elif bctype[j]=='symmetryPlane':os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value symmetryPlane'+opt)
	    elif bctype[j]=='empty':os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value empty'+opt)
	    elif bctype[j]=='cyclic':os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value cyclic'+opt)
	    elif bctype[j]=='cyclicAMI':os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value cyclicAMI'+opt)

	if opt==' ':opt='0'
	print 'epsilon Boundary Conditions are set as '+opt
    #------------------------------------------------------------------------------
    def omegaFile(self,turCondition,startFrom,startTime,nCore,internalField,turbulenceModel):

	GEN=generalClass(self.caseDir)
	eini=internalField[5]

	wallfunc='omegaWallFunction'
	#if turbulenceModel=='standardKEpsilon':wallfunc='omegaStdWallFunction'
	#elif turbulenceModel=='realizableKEpsilon':wallfunc='omegaStdWallFunction'
	#elif turbulenceModel=='renormalizationGroupKEpsilon':wallfunc='omegaStdWallFunction'
	#elif turbulenceModel=='shearStressTransportKOmega':wallfunc='omegaStdWallFunction'

	aa=glob.glob(self.caseDir+'/processor*')
	if len(aa)==0:
	    if startFrom=='startTime':
	        if startTime!='0':opt=' -time '+startTime
	        else:opt=' '
	    else:opt=' -latestTime'
	else:
	    if nCore!='1':
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime+' -parallel'
	            else:opt=' '
	        else:opt=' -latestTime -parallel'
	    else:
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime
	            else:opt=' '
	        else:opt=' -latestTime'

	bcname=GEN.getBCName();bctype=GEN.getBCType()

	for j in range(len(bcname)):
	    pp=bcname[j]
	    if bctype[j]=='wall' or bctype[j]=='patch':
		condition=turCondition[bcname[j]]
		patchType=condition[1];patchValue=[condition[2],condition[3]]
		if patchType=='wallFunction':
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value '+wallfunc+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry value -value '+eini+opt)
		elif patchType=='fixed-Value':
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value fixedValue'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry value -value '+patchValue[1]+opt)
		elif patchType=='zeroGradient':
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value zeroGradient'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry value -value '+eini+opt)
		elif patchType=='inletOutlet':
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value inletOutlet'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry inletValue -value '+patchValue[1]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry value -value '+eini+opt)
	    elif bctype[j]=='mappedWall':
	        os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value '+wallfunc+opt)
	        os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry value -value '+eini+opt)
	    elif bctype[j]=='symmetry':os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value symmetry'+opt)
	    elif bctype[j]=='symmetryPlane':os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value symmetryPlane'+opt)
	    elif bctype[j]=='empty':os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value empty'+opt)
	    elif bctype[j]=='cyclic':os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value cyclic'+opt)
	    elif bctype[j]=='cyclicAMI':os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value cyclicAMI'+opt)

	if opt==' ':opt='0'
	print 'omega Boundary Conditions are set as '+opt
    #------------------------------------------------------------------------------
    def nutFile(self,flowCondition,startFrom,startTime,nCore,turbulenceModel):

	GEN=generalClass(self.caseDir)

	wallfunc='nutkWallFunction'
	if turbulenceModel=='standardKEpsilon':wallfunc='nutStdWallFunction'
	elif turbulenceModel=='realizableKEpsilon':wallfunc='nutStdWallFunction'
	elif turbulenceModel=='renormalizationGroupKEpsilon':wallfunc='nutStdWallFunction'
	elif turbulenceModel=='shearStressTransportKOmega':wallfunc='nutStdWallFunction'

	aa=glob.glob(self.caseDir+'/processor*')
	if len(aa)==0:
	    if startFrom=='startTime':
	        if startTime!='0':opt=' -time '+startTime
	        else:opt=' '
	    else:opt=' -latestTime'
	else:
	    if nCore!='1':
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime+' -parallel'
	            else:opt=' '
	        else:opt=' -latestTime -parallel'
	    else:
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime
	            else:opt=' '
	        else:opt=' -latestTime'

	bcname=GEN.getBCName();bctype=GEN.getBCType()

	for j in range(len(bcname)):
	    pp=bcname[j]
	    if bctype[j]=='wall' or bctype[j]=='patch':
		condition=flowCondition[bcname[j]]
		patchType=condition[1];patchValue=[condition[2],condition[3],condition[4]]
		if patchType=='wall' or patchType=='moving-wall':
	            os.system('changeBCs -case '+self.caseDir+ ' -field nut -patch '+pp+' -entry type -value '+wallfunc+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field nut -patch '+pp+' -entry value -value 0'+opt)
		elif patchType=='fixed-U' or patchType=='surfaceNormal-U' or patchType=='volume-flowrate' or patchType=='mass-flowrate':
	            os.system('changeBCs -case '+self.caseDir+ ' -field nut -patch '+pp+' -entry type -value calculated'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field nut -patch '+pp+' -entry value -value 0'+opt)
		elif patchType=='outlet':
	            os.system('changeBCs -case '+self.caseDir+ ' -field nut -patch '+pp+' -entry type -value calculated'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field nut -patch '+pp+' -entry value -value 0'+opt)
	    elif bctype[j]=='mappedWall':
	        os.system('changeBCs -case '+self.caseDir+ ' -field nut -patch '+pp+' -entry type -value '+wallfunc+opt)
	        os.system('changeBCs -case '+self.caseDir+ ' -field nut -patch '+pp+' -entry value -value 0'+opt)
	    elif bctype[j]=='symmetry':os.system('changeBCs -case '+self.caseDir+ ' -field nut -patch '+pp+' -entry type -value symmetry'+opt)
	    elif bctype[j]=='symmetryPlane':os.system('changeBCs -case '+self.caseDir+ ' -field nut -patch '+pp+' -entry type -value symmetryPlane'+opt)
	    elif bctype[j]=='empty':os.system('changeBCs -case '+self.caseDir+ ' -field nut -patch '+pp+' -entry type -value empty'+opt)
	    elif bctype[j]=='cyclic':os.system('changeBCs -case '+self.caseDir+ ' -field nut -patch '+pp+' -entry type -value cyclic'+opt)
	    elif bctype[j]=='cyclicAMI':os.system('changeBCs -case '+self.caseDir+ ' -field nut -patch '+pp+' -entry type -value cyclicAMI'+opt)

	if opt==' ':opt='0'
	print 'nut Boundary Conditions are set as '+opt
    #------------------------------------------------------------------------------
    def changeInternalField(self,internalField,mode):
	f=open(self.caseDir+'/0/U','r');ff=f.readlines();f.close()
	for i in range(len(ff)):
	    if ff[i][:13]=='internalField':ff[i]='internalField    uniform ('+internalField[0]+' '+internalField[1]+' '+internalField[2]+'); \n'
	g=open(self.caseDir+'/0/U','w');
	for ii in ff:g.write(ii)
	g.close()

	f=open(self.caseDir+'/0/k','r');ff=f.readlines();f.close()
	for i in range(len(ff)):
	    if ff[i][:13]=='internalField':ff[i]='internalField    uniform '+internalField[4]+'; \n'
	g=open(self.caseDir+'/0/k','w');
	for ii in ff:g.write(ii)
	g.close()

	f=open(self.caseDir+'/0/epsilon','r');ff=f.readlines();f.close()
	for i in range(len(ff)):
	    if ff[i][:13]=='internalField':ff[i]='internalField    uniform '+internalField[5]+'; \n'
	g=open(self.caseDir+'/0/epsilon','w');
	for ii in ff:g.write(ii)
	g.close()

	f=open(self.caseDir+'/0/omega','r');ff=f.readlines();f.close()
	for i in range(len(ff)):
	    if ff[i][:13]=='internalField':ff[i]='internalField    uniform '+internalField[5]+'; \n'
	g=open(self.caseDir+'/0/omega','w');
	for ii in ff:g.write(ii)
	g.close()

	if mode=='incompressible':
	    f=open(self.caseDir+'/0/p','r');ff=f.readlines();f.close()
	    for i in range(len(ff)):
	        if ff[i][:13]=='internalField':ff[i]='internalField    uniform '+internalField[3]+'; \n'
	    g=open(self.caseDir+'/0/p','w');
	    for ii in ff:g.write(ii)
	    g.close()
	elif mode=='heatTransfer':
	    f=open(self.caseDir+'/0/p_rgh','r');ff=f.readlines();f.close()
	    for i in range(len(ff)):
	        if ff[i][:13]=='internalField':ff[i]='internalField    uniform '+internalField[3]+'; \n'
	    g=open(self.caseDir+'/0/p_rgh','w');
	    for ii in ff:g.write(ii)
	    g.close()

	    absp=float(internalField[3])+101325
	    f=open(self.caseDir+'/0/p','r');ff=f.readlines();f.close()
	    for i in range(len(ff)):
	        if ff[i][:13]=='internalField':ff[i]='internalField    uniform '+str(absp)+'; \n'
	    g=open(self.caseDir+'/0/p','w');
	    for ii in ff:g.write(ii)
	    g.close()

	    f=open(self.caseDir+'/0/T','r');ff=f.readlines();f.close()
	    for i in range(len(ff)):
	        if ff[i][:13]=='internalField':ff[i]='internalField    uniform '+internalField[6]+'; \n'
	    g=open(self.caseDir+'/0/omega','w');
	    for ii in ff:g.write(ii)
	    g.close()


    #------------------------------------------------------------------------------
    def UFileHeatTransfer(self,flowCondition,startFrom,startTime,nCore,rho,internalField):

	uini='('+internalField[0]+' '+internalField[1]+' '+internalField[2]+')'

	GEN=generalClass(self.caseDir)

	aa=glob.glob(self.caseDir+'/processor*')
	if len(aa)==0:
	    if startFrom=='startTime':
	        if startTime!='0':opt=' -time '+startTime
	        else:opt=' '
	    else:opt=' -latestTime'
	else:
	    if nCore!='1':
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime+' -parallel'
	            else:opt=' '
	        else:opt=' -latestTime -parallel'
	    else:
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime
	            else:opt=' '
	        else:opt=' -latestTime'

	bcname=GEN.getBCName();bctype=GEN.getBCType()

	for j in range(len(bcname)):
	    pp=bcname[j]
	    if bctype[j]=='wall' or bctype[j]=='patch' or bctype[j]=='mappedWall':
		condition=flowCondition[bcname[j]]
		patchType=condition[1];patchValue=[condition[2],condition[3],condition[4]]
		if patchType=='wall':
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value fixedValue'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+" -entry value -value '(0 0 0)'"+opt)
		elif patchType=='moving-wall' or patchType=='fixed-U':
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value fixedValue'+opt)
		    valuestr="'("+patchValue[0]+' '+patchValue[1]+' '+patchValue[2]+")'"
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry value -value '+valuestr+opt)
		elif patchType=='surfaceNormal-U':
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value surfaceNormalFixedValue'+opt)
		    if float(patchValue[0]) > 0 :refv='-'+patchValue[0]
		    else:
			aa=float(patchValue[0])*-1;refv='-'+aa
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry refValue -value '+refv+opt)
		elif patchType=='volume-flowrate':
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value flowRateInletVelocity'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry volumetricFlowRate -value '+patchValue[0]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry value -value '+"'"+uini+"'"+opt)
		elif patchType=='mass-flowrate':
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value flowRateInletVelocity'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry massFlowRate -value '+patchValue[0]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry rho -value rho'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry rhoInlet -value '+rho+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry value -value '+"'"+uini+"'"+opt)
		elif patchType=='total-pressure':
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value zeroGradient'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry value -value '+"'"+uini+"'"+opt)
		elif patchType=='outlet':
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value pressureInletOutletVelocity'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry value -value '+"'"+uini+"'"+opt)
		elif patchType=='movingWallVelocity':
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value movingWallVelocity'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+" -entry value -value '(0 0 0)'"+opt)
		elif patchType=='rotatingWallVelocity':
		    if patchValue[1]=='x':axis='(1 0 0)'
		    elif patchValue[1]=='y':axis='(0 1 0)'
		    elif patchValue[1]=='z':axis='(0 0 1)'
		    elif patchValue[1]=='-x':axis='(-1 0 0)'
		    elif patchValue[1]=='-y':axis='(0 -1 0)'
		    elif patchValue[1]=='-z':axis='(0 0 -1)'
		    omega=float(patchValue[2])*2*3.141592/60;omega=str(omega)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value rotatingWallVelocity'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry origin -value '+"'"+patchValue[0]+"'"+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry axis -value '+"'"+axis+"'"+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry omega -value '+omega+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+" -entry value -value '(0 0 0)'"+opt)
	    elif bctype[j]=='symmetry':os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value symmetry'+opt)
	    elif bctype[j]=='symmetryPlane':os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value symmetryPlane'+opt)
	    elif bctype[j]=='empty':os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value empty'+opt)
	    elif bctype[j]=='cyclic':os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value cyclic'+opt)
	    elif bctype[j]=='cyclicAMI':os.system('changeBCs -case '+self.caseDir+ ' -field U -patch '+pp+' -entry type -value cyclicAMI'+opt)

	if opt==' ':opt='0'
	print 'U Boundary Conditions are set as '+opt

    #------------------------------------------------------------------------------
    def p_rghFile(self,flowCondition,jump,startFrom,startTime,nCore,internalField):

	GEN=generalClass(self.caseDir)
	pini=internalField[3]

	aa=glob.glob(self.caseDir+'/processor*')
	if len(aa)==0:
	    if startFrom=='startTime':
	        if startTime!='0':opt=' -time '+startTime
	        else:opt=' '
	    else:opt=' -latestTime'
	else:
	    if nCore!='1':
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime+' -parallel'
	            else:opt=' '
	        else:opt=' -latestTime -parallel'
	    else:
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime
	            else:opt=' '
	        else:opt=' -latestTime'

	bcname=GEN.getBCName();bctype=GEN.getBCType()

	for j in range(len(bcname)):
	    pp=bcname[j]
	    if bctype[j]=='wall' or bctype[j]=='patch':
		condition=flowCondition[bcname[j]]
		patchType=condition[1];patchValue=[condition[2],condition[3],condition[4]]
		if patchType=='total-pressure':
	            os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry type -value totalPressure'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry gamma -value 1.4'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry p0 -value '+patchValue[0]+opt)
		elif patchType=='outlet':
	            os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry type -value fixedValue'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry value -value '+patchValue[0]+opt)
		else:
	            os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry type -value fixedFluxPressure'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry value -value '+pini+opt)
	    elif bctype[j]=='mappedWall':
	        os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry type -value zeroGradient'+opt)
	        os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry value -value '+pini+opt)
	    elif bctype[j]=='cyclic':
		aa=jump.keys();bb=aa.count(bcname[j])
		if bb!=0:
	            os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry type -value porousJumpPressure'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry patchType -value cyclic'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry value -value '+patchValue[0]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry D -value '+jump[bcname[j]][0]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry I -value '+jump[bcname[j]][1]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry length -value '+jump[bcname[j]][2]+opt)
	    	else:
		    os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry type -value cyclic'+opt)
	    elif bctype[j]=='symmetry':os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry type -value symmetry'+opt)
	    elif bctype[j]=='symmetryPlane':os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry type -value symmetryPlane'+opt)
	    elif bctype[j]=='empty':os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry type -value empty'+opt)
	    elif bctype[j]=='cyclicAMI':os.system('changeBCs -case '+self.caseDir+ ' -field p_rgh -patch '+pp+' -entry type -value cyclicAMI'+opt)

	if opt==' ':opt='0'
	print 'p_rgh Boundary Conditions are set as '+opt
    #------------------------------------------------------------------------------
    def kFileHeatTransfer(self,turCondition,startFrom,startTime,nCore,internalField):

	GEN=generalClass(self.caseDir)
	kini=internalField[4]

	aa=glob.glob(self.caseDir+'/processor*')
	if len(aa)==0:
	    if startFrom=='startTime':
	        if startTime!='0':opt=' -time '+startTime
	        else:opt=' '
	    else:opt=' -latestTime'
	else:
	    if nCore!='1':
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime+' -parallel'
	            else:opt=' '
	        else:opt=' -latestTime -parallel'
	    else:
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime
	            else:opt=' '
	        else:opt=' -latestTime'

	bcname=GEN.getBCName();bctype=GEN.getBCType()

	for j in range(len(bcname)):
	    pp=bcname[j]
	    if bctype[j]=='wall' or bctype[j]=='patch':
		condition=turCondition[bcname[j]]
		patchType=condition[1];patchValue=[condition[2],condition[3]]
		if patchType=='wallFunction':
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value compressible::kqRWallFunction'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry value -value '+kini+opt)
		elif patchType=='fixed-Value':
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value fixedValue'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry value -value '+patchValue[0]+opt)
		elif patchType=='zeroGradient':
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value zeroGradient'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry value -value '+kini+opt)
		elif patchType=='inletOutlet':
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value inletOutlet'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry inletValue -value '+patchValue[0]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry value -value '+kini+opt)
	    elif bctype[j]=='mappedWall':
	        os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value compressible::kqRWallFunction'+opt)
	        os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry value -value '+kini+opt)
	    elif bctype[j]=='symmetry':os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value symmetry'+opt)
	    elif bctype[j]=='symmetryPlane':os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value symmetryPlane'+opt)
	    elif bctype[j]=='empty':os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value empty'+opt)
	    elif bctype[j]=='cyclic':os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value cyclic'+opt)
	    elif bctype[j]=='cyclicAMI':os.system('changeBCs -case '+self.caseDir+ ' -field k -patch '+pp+' -entry type -value cyclicAMI'+opt)

	if opt==' ':opt='0'
	print 'k Boundary Conditions are set as '+opt
    #------------------------------------------------------------------------------
    def epsilonFileHeatTransfer(self,turCondition,startFrom,startTime,nCore,internalField,turbulenceModel):

	GEN=generalClass(self.caseDir)
	eini=internalField[5]

	wallfunc='compressible::epsilonWallFunction'
	#if turbulenceModel=='standardKEpsilon':wallfunc='epsilonStdWallFunction'
	#elif turbulenceModel=='realizableKEpsilon':wallfunc='epsilonStdWallFunction'
	#elif turbulenceModel=='renormalizationGroupKEpsilon':wallfunc='epsilonStdWallFunction'
	#elif turbulenceModel=='shearStressTransportKOmega':wallfunc='epsilonStdWallFunction'

	aa=glob.glob(self.caseDir+'/processor*')
	if len(aa)==0:
	    if startFrom=='startTime':
	        if startTime!='0':opt=' -time '+startTime
	        else:opt=' '
	    else:opt=' -latestTime'
	else:
	    if nCore!='1':
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime+' -parallel'
	            else:opt=' '
	        else:opt=' -latestTime -parallel'
	    else:
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime
	            else:opt=' '
	        else:opt=' -latestTime'

	bcname=GEN.getBCName();bctype=GEN.getBCType()

	for j in range(len(bcname)):
	    pp=bcname[j]
	    if bctype[j]=='wall' or bctype[j]=='patch':
		condition=turCondition[bcname[j]]
		patchType=condition[1];patchValue=[condition[2],condition[3]]
		if patchType=='wallFunction':
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value '+wallfunc+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry value -value '+eini+opt)
		elif patchType=='fixed-Value':
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value fixedValue'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry value -value '+patchValue[1]+opt)
		elif patchType=='zeroGradient':
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value zeroGradient'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry value -value '+eini+opt)
		elif patchType=='inletOutlet':
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value inletOutlet'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry inletValue -value '+patchValue[1]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry value -value '+eini+opt)
	    elif bctype[j]=='mappedWall':
	        os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value '+wallfunc+opt)
	        os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry value -value '+eini+opt)
	    elif bctype[j]=='symmetry':os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value symmetry'+opt)
	    elif bctype[j]=='symmetryPlane':os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value symmetryPlane'+opt)
	    elif bctype[j]=='empty':os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value empty'+opt)
	    elif bctype[j]=='cyclic':os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value cyclic'+opt)
	    elif bctype[j]=='cyclicAMI':os.system('changeBCs -case '+self.caseDir+ ' -field epsilon -patch '+pp+' -entry type -value cyclicAMI'+opt)

	if opt==' ':opt='0'
	print 'epsilon Boundary Conditions are set as '+opt
    #------------------------------------------------------------------------------
    def omegaFileHeatTransfer(self,turCondition,startFrom,startTime,nCore,internalField,turbulenceModel):

	GEN=generalClass(self.caseDir)
	eini=internalField[5]

	wallfunc='compressible::omegaWallFunction'
	#if turbulenceModel=='standardKEpsilon':wallfunc='omegaStdWallFunction'
	#elif turbulenceModel=='realizableKEpsilon':wallfunc='omegaStdWallFunction'
	#elif turbulenceModel=='renormalizationGroupKEpsilon':wallfunc='omegaStdWallFunction'
	#elif turbulenceModel=='shearStressTransportKOmega':wallfunc='omegaStdWallFunction'

	aa=glob.glob(self.caseDir+'/processor*')
	if len(aa)==0:
	    if startFrom=='startTime':
	        if startTime!='0':opt=' -time '+startTime
	        else:opt=' '
	    else:opt=' -latestTime'
	else:
	    if nCore!='1':
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime+' -parallel'
	            else:opt=' '
	        else:opt=' -latestTime -parallel'
	    else:
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime
	            else:opt=' '
	        else:opt=' -latestTime'

	bcname=GEN.getBCName();bctype=GEN.getBCType()

	for j in range(len(bcname)):
	    pp=bcname[j]
	    if bctype[j]=='wall' or bctype[j]=='patch':
		condition=turCondition[bcname[j]]
		patchType=condition[1];patchValue=[condition[2],condition[3]]
		if patchType=='wallFunction':
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value '+wallfunc+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry value -value '+eini+opt)
		elif patchType=='fixed-Value':
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value fixedValue'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry value -value '+patchValue[1]+opt)
		elif patchType=='zeroGradient':
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value zeroGradient'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry value -value '+eini+opt)
		elif patchType=='inletOutlet':
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value inletOutlet'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry inletValue -value '+patchValue[1]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry value -value '+eini+opt)
	    elif bctype[j]=='mappedWall':
	        os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value '+wallfunc+opt)
	        os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry value -value '+eini+opt)
	    elif bctype[j]=='symmetry':os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value symmetry'+opt)
	    elif bctype[j]=='symmetryPlane':os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value symmetryPlane'+opt)
	    elif bctype[j]=='empty':os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value empty'+opt)
	    elif bctype[j]=='cyclic':os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value cyclic'+opt)
	    elif bctype[j]=='cyclicAMI':os.system('changeBCs -case '+self.caseDir+ ' -field omega -patch '+pp+' -entry type -value cyclicAMI'+opt)

	if opt==' ':opt='0'
	print 'omega Boundary Conditions are set as '+opt

    #------------------------------------------------------------------------------
    def TFile(self,thermalCondition,startFrom,startTime,nCore,internalField):

	GEN=generalClass(self.caseDir)
	Tini=internalField[6]

	aa=glob.glob(self.caseDir+'/processor*')
	if len(aa)==0:
	    if startFrom=='startTime':
	        if startTime!='0':opt=' -time '+startTime
	        else:opt=' '
	    else:opt=' -latestTime'
	else:
	    if nCore!='1':
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime+' -parallel'
	            else:opt=' '
	        else:opt=' -latestTime -parallel'
	    else:
	        if startFrom=='startTime':
	            if startTime!='0':opt=' -time '+startTime
	            else:opt=' '
	        else:opt=' -latestTime'

	bcname=GEN.getBCName();bctype=GEN.getBCType()

	for j in range(len(bcname)):
	    pp=bcname[j]
	    if bctype[j]=='wall' or bctype[j]=='patch':
		condition=thermalCondition[bcname[j]]
		patchType=condition[0];patchValue=[condition[1],condition[2],condition[3]]
		if patchType=='zeroGradient':
	            os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry type -value zeroGradient'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry value -value '+Tini+opt)
		elif patchType=='fixedValue':
	            os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry type -value fixedValue'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry value -value '+patchValue[0]+opt)
		elif patchType=='heatflux':
	            os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry type -value externalWallHeatFluxTemperature'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry kappa -value fluidThermo'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry q -value '+patchValue[0]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry kappaName -value none'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry value -value '+Tini+opt)
		elif patchType=='convection':
	            os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry type -value externalWallHeatFluxTemperature'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry kappa -value fluidThermo'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry Ta -value '+patchValue[0]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry h -value '+patchValue[1]+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry kappaName -value none'+opt)
	            os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry value -value '+Tini+opt)
	    elif bctype[j]=='mappedWall':
	        os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry type -value compressible::turbulentTemperatureCoupledBaffleMixed'+opt)
	        os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry Tnbr -value T'+opt)
	        os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry kappa -value fluidThermo'+opt)
	        os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry kappaName -value none'+opt)
	        os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry value -value '+tini+opt)
	    elif bctype[j]=='symmetry':os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry type -value symmetry'+opt)
	    elif bctype[j]=='symmetryPlane':os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry type -value symmetryPlane'+opt)
	    elif bctype[j]=='empty':os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry type -value empty'+opt)
	    elif bctype[j]=='cyclic':os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry type -value cyclic'+opt)
	    elif bctype[j]=='cyclicAMI':os.system('changeBCs -case '+self.caseDir+ ' -field T -patch '+pp+' -entry type -value cyclicAMI'+opt)

	if opt==' ':opt='0'
	print 'T Boundary Conditions are set as '+opt


